"use strict"

class NativeSoundPlayer extends SoundPlayer{
  constructor(){
    super()
  }

  loadChannels(){
    this._loadChannel("OPENING", "opening", 3000)
    this._loadChannel("PIECE_NORMAL", "piece")
    this._loadChannel("PIECE_DOUBLE", "piece_double")
    this._loadChannel("PIECE_DOBUTSU", "piece34")
    this._loadChannel("CHALLENGER", "challenger")
    this._loadChannel("INVITATION", "invitation")
    this._loadChannel("CHIME", "chime")
    this._loadChannel("GAME_START", "start")
    this._loadChannel("WIN", "win")
    this._loadChannel("LOSE", "lose")
    this._loadChannel("CHAT1", "chat_lobby")
    this._loadChannel("CHAT2", "chat_board")
    this._loadChannel("NOTIFY", "chat_notify")
    this._loadChannel("DOOR_OPEN", "fusuma_open")
    this._loadChannel("DOOR_CLOSE", "fusuma_close")
    this._loadChannel("HOVER", "hover")
    this._loadChannel("CLICK_NORMAL", "click_normal")
    this._loadChannel("CLICK_CANCEL", "click_cancel")
    this._loadChannel("CLICK_EXEC", "click_exec")
    this._loadChannel("AUTOMATCH_CONFIRM", "automatch_confirm")
    this._loadChannel("AUTOMATCH_START", "automatch_start")
  }

  startOpening(){
    window.plugins.NativeAudio.loop("OPENING")
  }

  stopOpening(){
    window.plugins.NativeAudio.stop("OPENING")
  }

  muteOpening(toggle){
    this._setVolume("OPENING", toggle ? 0 : 1)
  }

  startAutomatchConfirm(){
    window.plugins.NativeAudio.loop("AUTOMATCH_CONFIRM")
  }

  stopAutomatchConfirm(){
    window.plugins.NativeAudio.stop("AUTOMATCH_CONFIRM")
  }

  _setVolume(key, volume){
    window.plugins.NativeAudio.setVolumeForComplexAsset(key, volume)
  }

  play(key){
    if (this._inactive) return
    window.plugins.NativeAudio.play(key)
  }

  _loadChannel(key, file, delay = 0){
    window.plugins.NativeAudio.preloadComplex(key, SoundPlayer.CONST.SOUND_PATH+ "/" + file + ".mp3", 1, 1, delay, null, function(msg){
      if (msg.match(/already\sexists/)) {
        window.plugins.NativeAudio.unload(key, function(msg){
          window.plugins.NativeAudio.preloadComplex(key, SoundPlayer.CONST.SOUND_PATH+ "/" + file + ".mp3", 1, 1, delay)
        })
      }
    })
  }

}
